Bug 461816 - Broker sends message.transfer after sending a session.detach
Broker sends message.transfer after sending a session.detach
Status: CLOSED ERRATA
Product: Red Hat Enterprise MRG
Classification: Red Hat
Component: qpid-cpp (Show other bugs)
1.0
All Linux
urgent Severity urgent
: 1.1
: ---
Assigned To: Gordon Sim
Kim van der Riet
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-09-10 16:03 EDT by Gordon Sim
Modified: 2009-02-04 10:35 EST (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-02-04 10:35:17 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Test case (2.98 KB, text/x-python)
2008-11-06 12:45 EST, Gordon Sim
no flags Details
qpid_test_msg_trasfer_after_session_detach_bz461816 failing test (97.36 KB, application/x-bzip2)
2008-11-10 06:40 EST, Frantisek Reznicek
no flags Details


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHEA-2009:0035 normal SHIPPED_LIVE Red Hat Enterprise MRG Messaging 1.1 Release 2009-02-04 10:33:44 EST

  None (edit)
Description Gordon Sim 2008-09-10 16:03:57 EDT
It should not send anything after the detach (or indeed after the execution.exception).
Comment 1 Gordon Sim 2008-10-30 07:27:44 EDT
Also tracked by https://issues.apache.org/jira/browse/QPID-1413
Comment 2 Gordon Sim 2008-11-06 12:45:57 EST
Created attachment 322765 [details]
Test case

This is quite hard to observe from an application. I was discovered when using the python client and the attached application emulates that use case. As the channel is reused, transfers that arrive after the detach is sent cause problems for the subsequently attached sessions.

The failure exhibits itself when running this test app by something like the following:

Exception in thread Thread-2:
Traceback (most recent call last):
  File "/usr/lib/python2.4/threading.py", line 442, in __bootstrap
    self.run()
  File "/usr/lib/python2.4/threading.py", line 422, in run
    self.__target(*self.__args, **self.__kwargs)
  File "/home/gordon/qpid/trunk/qpid/python/qpid/connection.py", line 175, in run
    self.delegate.received(seg)
  File "/home/gordon/qpid/trunk/qpid/python/qpid/delegates.py", line 50, in received
    ssn.received(seg)
  File "/home/gordon/qpid/trunk/qpid/python/qpid/session.py", line 220, in received
    self.receiver.received(seg)
  File "/home/gordon/qpid/trunk/qpid/python/qpid/session.py", line 280, in received
    raise Exception("todo")
Exception: todo
Comment 3 Gordon Sim 2008-11-06 13:25:27 EST
Fixed by r711931. Attached test case runs without error.
Comment 4 Frantisek Reznicek 2008-11-10 06:40:17 EST
Created attachment 323058 [details]
qpid_test_msg_trasfer_after_session_detach_bz461816 failing test
Comment 5 Frantisek Reznicek 2008-11-10 06:41:08 EST
RHTS test qpid_test_msg_trasfer_after_session_detach_bz461816 almost finished.
The result of the test shows that issue is not gone.

See attached current state of test including logfile (python core test logfile & qpidd trace log)
See common_transcript lines 9173-9188.

Observed on RHEL5.2 x86_64, qpidd-0.3.711915-2.el5, rhm-0.2.2694-1.el5
Comment 6 Frantisek Reznicek 2008-11-10 08:59:49 EST
RHTS test qpid_test_msg_trasfer_after_session_detach_bz461816 updated and qpidd version updated to revision > 711931.
Test passing on multiple machines (RHEL4.7/5.2 i386/x86_64).
-> VERIFIED
Comment 8 errata-xmlrpc 2009-02-04 10:35:17 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHEA-2009-0035.html

Note You need to log in before you can comment on or make changes to this bug.